// NetFinderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetFinder.h"
#include "NetFinderDlg.h"
#include "staticLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STATUS_BAR_N 457
// 
#define ANI_START_FRAME 22
//   -
#define IID_DEFAULT			0
#define IID_DOMAIN			1
#define IID_GROUP				2
#define IID_REMOTECOMP	3
#define IID_SHARE				4
#define IID_FOLDER			5
//  .    Shell32.dll
int Icons[] = {1,//  
	15, //  
	19, // 
	16, // 
	43, // 
	4,  //
	0}; //   

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
	CStaticLink m_MailLink;
	CStaticLink m_HomeLink;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_MailLink.SubclassDlgItem(IDC_MAIL, this);
	m_MailLink.m_link = "mailto:rnasyrov@chat.ru?subject=NetFinder rulez !";
	m_HomeLink.SubclassDlgItem(IDC_HOMEPAGE, this);	
	// TODO: Add extra initialization here
	TCHAR s[900];
	::LoadString(NULL,IDS_ABOUT,s,899);
	SetDlgItemText(IDC_EDIT2,s);
	
	return TRUE;  
}
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetFinderDlg dialog

CNetFinderDlg::CNetFinderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNetFinderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNetFinderDlg)  
	m_SearchTempl = _T("*.*");
	//}}AFX_DATA_INIT
	CoInitialize(NULL); 
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_aFindedFiles.SetSize(100,100);
	//         
	m_hShellDll = LoadLibrary("shell32.dll");
	m_bInAir = FALSE; //    
	m_iBaseIconQty = 0;
}

CNetFinderDlg::~CNetFinderDlg()
{
  FreeLibrary(m_hShellDll);
	CoUninitialize( );
}
void CNetFinderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNetFinderDlg)
	DDX_Control(pDX, IDC_ANIMATE1, m_AniCtrl);
	DDX_Control(pDX, IDC_TREE1, m_NetTree);
	DDX_Text(pDX, IDC_EDIT1, m_SearchTempl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNetFinderDlg, CDialog)
	//{{AFX_MSG_MAP(CNetFinderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_GOSEARCH, OnSearch)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE1, OnDblclkTree)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetFinderDlg message handlers

BOOL CNetFinderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//  
	RECT r = {0,0,0,0};
	m_StatusBar.Create(WS_CHILD|WS_VISIBLE/*|SBARS_SIZEGRIP*/,r,this,STATUS_BAR_N);
	int Parts[] = {-1};
	m_StatusBar.SetParts(1,Parts);
	// 
	::SetWindowLong(m_AniCtrl.m_hWnd,GWL_HINSTANCE,(LONG)m_hShellDll);
	m_AniCtrl.Open(150);
	m_AniCtrl.Seek(ANI_START_FRAME);
	//     
	m_IconList.Create(16,16,ILC_MASK,7,10);
	int i=0;
	while (Icons[i])
		m_IconList.Add(::LoadIcon(m_hShellDll,MAKEINTRESOURCE(Icons[i++])));
	m_iBaseIconQty = i;
	//    
	m_NetTree.SetImageList(&m_IconList,TVSIL_NORMAL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNetFinderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		OnAbout();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNetFinderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

BOOL WINAPI CNetFinderDlg::EnumerateFunc(HWND hwnd, 
                             HTREEITEM hParent,
                          LPNETRESOURCE lpnr)
{ 
  DWORD dwResult, dwResultEnum;
  HANDLE hEnum;
  DWORD cbBuffer = 16384;      // 16K  
  DWORD cEntries = 0xFFFFFFFF; //   
  LPNETRESOURCE lpnrLocal;     //     
  DWORD i;
	HTREEITEM hNewParent;
	BOOL AnyFinded = FALSE;
  // 
	dwResult = WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,
                          0,        //   
                          lpnr,     //    NULL 
                          &hEnum);  //  
	//   
  if (dwResult != NO_ERROR)
      return FALSE;
  //   ,     
  lpnrLocal = (LPNETRESOURCE) GlobalAlloc(GPTR, cbBuffer);
	// ,     
  do
  {  
    ZeroMemory(lpnrLocal, cbBuffer);
    dwResultEnum = WNetEnumResource(hEnum, &cEntries, lpnrLocal,
                                    &cbBuffer); //     lpnrLocal
		//   ,     lpnrLocal. 
		//   
    if (dwResultEnum == NO_ERROR)
    {
//			if (cEntries>2)
		//		 cEntries = 2;
      for(i = 0; i < cEntries; i++)
      {
				//     ,  
				if (!m_bInAir)
				{
					dwResultEnum = ERROR_NO_MORE_ITEMS;
					break;
				};
				//   ,   ""   
				//   9x      NULL
				char *p;
				if (lpnrLocal[i].lpRemoteName)
				{
					p = strrchr(lpnrLocal[i].lpRemoteName,'\\');
					if (p)
						p++;
					else
						p = lpnrLocal[i].lpRemoteName;
				}
				else
					p = "Windows Network";
				//   
				hNewParent = m_NetTree.InsertItem(p,hParent);
				//       
				int ImgIdx;
				switch (lpnrLocal[i].dwDisplayType)
				{
						case RESOURCEDISPLAYTYPE_DOMAIN:	ImgIdx = IID_GROUP; break;
						case RESOURCEDISPLAYTYPE_SERVER:	ImgIdx = IID_REMOTECOMP; break;
						case RESOURCEDISPLAYTYPE_SHARE:		ImgIdx = IID_SHARE; break;
						case RESOURCEDISPLAYTYPE_GENERIC:	ImgIdx = IID_GROUP; break;
						default: ImgIdx = IID_DOMAIN; break;
				};
				m_NetTree.SetItemImage( hNewParent, ImgIdx, ImgIdx );
			//	m_NetTree.Expand(hParent,TVE_EXPAND);
				m_NetTree.UpdateWindow();
				//    
				SetStatusText(lpnrLocal[i].lpRemoteName);
				//   
        if(RESOURCEUSAGE_CONTAINER == (lpnrLocal[i].dwUsage
                                       & RESOURCEUSAGE_CONTAINER))
				{	
					//   
					if(EnumerateFunc(hwnd, hNewParent, &lpnrLocal[i]))
							AnyFinded = TRUE;
					else
						m_NetTree.DeleteItem(hNewParent);
				}
				else //          
					if(FindFiles(hNewParent,lpnrLocal[i].lpRemoteName,m_SearchTempl))
					{
						AnyFinded = TRUE;
						m_NetTree.SetItemImage( hNewParent, IID_SHARE	, IID_SHARE);
					}
					else
						m_NetTree.DeleteItem(hNewParent);
      }
    }
    else 
			if (dwResultEnum != ERROR_NO_MORE_ITEMS)
          break;
  }
  while(dwResultEnum != ERROR_NO_MORE_ITEMS);
	//  
  GlobalFree((HGLOBAL)lpnrLocal);
  dwResult = WNetCloseEnum(hEnum);
	//  
  return AnyFinded;
}

//    lpFileMask   lpFolderName    :)  
//    FindFilesInSubDir.   
//  m_NetTree   hParent.  -   lpFileMask 
// ,   TRUE,  FALSE
BOOL CNetFinderDlg::FindFiles(HTREEITEM hParent, 
															LPCTSTR lpFolderName, 
															LPCTSTR lpFileMask)
{
	HTREEITEM hNewParent;
	HANDLE hResult;
	BOOL bResult = TRUE;
	WIN32_FIND_DATA FindFileData;
	BOOL AnyFileFinded = FALSE,
		   AnyDirFinded= FALSE;
	int count = 0;
	char *p = NULL;
	CString FullName(lpFolderName);
	//   
	FullName += '\\';
	FullName += lpFileMask;
  //   
	hResult = FindFirstFile(FullName, &FindFileData);
	if (hResult != INVALID_HANDLE_VALUE)
		do
		{ 
			//     ,  
			if (!m_bInAir)
				break;
			// ,   ,      
			CString FindedFileName(lpFolderName);
			FindedFileName += '\\';
			FindedFileName += FindFileData.cFileName;
			SetStatusText(FindedFileName);
			//  
			if (strcmp(FindFileData.cFileName,".") && strcmp(FindFileData.cFileName,".."))
			{
				//    \
				p = FindFileData.cFileName;
				//   
				hNewParent = m_NetTree.InsertItem(p,hParent);
				//  \   ,     
				//  
				DWORD i = m_aFindedFiles.Add(FindedFileName);
				m_NetTree.SetItemData( hNewParent, i+1);
				//  ,      
				if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				{	//     
					AnyDirFinded = TRUE;
					AnyFileFinded = TRUE;
					//  
					m_NetTree.SetItemImage( hNewParent, IID_FOLDER, IID_FOLDER);
					//     
					CString FolderName(lpFolderName);
					FolderName += '\\';	FolderName += FindFileData.cFileName;
					//,        
					if (!FindFiles(hNewParent,FolderName,"*.*"/*lpFileMask*/))
						m_NetTree.DeleteItem(hNewParent);
				}
				else
				{//    
					//   
					AnyFileFinded = TRUE;
					//    
					m_iFindedItem ++; 
					//     
					SetFileIcon(hNewParent);
				};
		};
		//  
		bResult = FindNextFile(hResult, &FindFileData);
		count ++;
  }
  while ((bResult)/* && (count<8)*/);

  bResult = FindClose(hResult);
	//  ,     
	if ((!AnyDirFinded) && (m_bInAir))
		if (FindFilesInSubDir(hParent,lpFolderName,lpFileMask))
				AnyFileFinded = TRUE;
	
  return AnyFileFinded;
}
//   Go\Stop
void CNetFinderDlg::OnSearch() 
{
	if (m_bInAir)
	{
		m_bInAir = FALSE;
		CWnd *w = GetDlgItem(IDC_GOSEARCH);
		w->EnableWindow(FALSE);
//		WaitForSingleObject(m_hSearchMutex,INFINITE);
	}
	else
	{	// 
		UpdateData(TRUE);
		//    
		AfxBeginThread(ThreadSearchProc, this);
	};	
};
//    lpFileMask     lpFolderName 
//     m_NetTree   hParent.  -
//  lpFileMask  ,   TRUE,  FALSE
//      FindFiles
BOOL CNetFinderDlg::FindFilesInSubDir(HTREEITEM hParent, 
																			LPCTSTR lpFolderName, 
																			LPCTSTR lpFileMask)
{
	HTREEITEM hNewParent;
	HANDLE hResult;
	BOOL bResult = TRUE;
	WIN32_FIND_DATA FindFileData;
	BOOL AnyFileFinded = FALSE;
	int count = 0;
	CString FullName(lpFolderName);

	FullName += "\\*.*";
	//       
	hResult = FindFirstFile(FullName, &FindFileData);
	if (hResult == INVALID_HANDLE_VALUE)
    return FALSE;
	// 
  do
  { 
		//     ,  
		if (!m_bInAir)
				break;
		if (strcmp(FindFileData.cFileName,".") && strcmp(FindFileData.cFileName,".."))
		{
			//    ,      
			if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
			{	//     .     
				hNewParent = m_NetTree.InsertItem(FindFileData.cFileName,hParent);
				m_NetTree.SetItemImage( hNewParent, IID_FOLDER, IID_FOLDER);
				//       
				CString FolderName(lpFolderName);
				FolderName += '\\';
				FolderName += FindFileData.cFileName;
				//    
				SetStatusText(FolderName);
				//    ,       
				DWORD i = m_aFindedFiles.Add(FolderName);
				m_NetTree.SetItemData( hNewParent, i+1);
				//   
				if (FindFiles(hNewParent,FolderName,lpFileMask))
					AnyFileFinded = TRUE;
				else
					m_NetTree.DeleteItem(hNewParent);
			};
		};
		//  
		bResult = FindNextFile(hResult, &FindFileData);
		count ++; //   ,     
  }
  while ((bResult) /*&& (count<10)*/);
	//    
  bResult = FindClose(hResult);
  return AnyFileFinded;
}
//    
void CNetFinderDlg::SetStatusText(LPCTSTR StatusText)
{
	m_StatusBar.SetText(StatusText,0,0);
}
//     
void CNetFinderDlg::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HTREEITEM hTreeItem = m_NetTree.GetSelectedItem( );
	DWORD i = m_NetTree.GetItemData(hTreeItem);
	//  
	if (i>0)
	{
		AfxBeginThread(ThreadShellExecute, (LPVOID)((LPCTSTR)m_aFindedFiles.GetAt(i-1)));
		return;
		//     
		CString FileName = m_aFindedFiles.GetAt(i-1);
		CString FolderName = FileName;
		int i = FileName.ReverseFind('.');
		if (i != -1)
		{
			i = FileName.ReverseFind('\\');
			FolderName = FileName.Left(i);
		};
		//    !
		ShellExecute(m_hWnd,"open",FileName,NULL,FolderName,SW_SHOWNORMAL);
	};
	*pResult = 0;
}
//    
void CNetFinderDlg::Search()
{
	//  
	SearchStart();
	//  ,    	 
	EnumerateFunc(0,TVI_ROOT,NULL);	
	// 
	SearchEnd();
}
//   
void CNetFinderDlg::SearchStart()
{
	// .     .
	m_bInAir = TRUE;
	m_hSearchMutex = CreateMutex(NULL,TRUE,SEARCH_MYTEX_NAME);
	// 
	m_NetTree.DeleteAllItems();
	m_aFindedFiles.RemoveAll();
	m_iFindedItem = 0;
	//   
	if (m_SearchTempl.IsEmpty())
		m_SearchTempl = "*.*";
	//  
	HWND hEditWnd;
	GetDlgItem(IDC_EDIT1,&hEditWnd);
	::EnableWindow(hEditWnd,FALSE);
	//   
	CString str;
	str.LoadString(IDS_STOP);
	SetDlgItemText(IDC_GOSEARCH,str);
	// 
	m_AniCtrl.Open(150);
	m_AniCtrl.Play(0,-1,-1);
}
//   
void CNetFinderDlg::SearchEnd()
{
	// 
	TCHAR msg1[500],msg[600];
	::LoadString(NULL,IDS_END_FIND,msg1,499);
	sprintf(msg,msg1,m_iFindedItem);
	
	CString Msg(msg);
	int i = m_aFindedFiles.Add(Msg);
	SetStatusText(m_aFindedFiles.GetAt(i));
	//  
	m_NetTree.EnableWindow();
	m_NetTree.ShowWindow(SW_SHOW);
	HWND hEditWnd;
	GetDlgItem(IDC_EDIT1,&hEditWnd);
	::EnableWindow(hEditWnd,TRUE);
	//   
	CString str;
	str.LoadString(IDS_GO);
	SetDlgItemText(IDC_GOSEARCH,str);
	// 
	m_AniCtrl.Stop();
	m_AniCtrl.Seek(ANI_START_FRAME);
	// .     .
	m_bInAir = FALSE;
	ReleaseMutex(m_hSearchMutex);
	CloseHandle(m_hSearchMutex);
	//  
	CWnd *w = GetDlgItem(IDC_GOSEARCH);
	w->EnableWindow(TRUE);
}
//     ,   
//  .      
//   m_aFindedFiles,   
void CNetFinderDlg::SetFileIcon(HTREEITEM hItem)
{
	int iStrIdx,i,idx;
	CString FileName;
	SHFILEINFO psfi;

	//     m_aFindedFiles
	iStrIdx = m_NetTree.GetItemData(hItem);
	if (iStrIdx > 0)
	{ //  ,     
		FileName = m_aFindedFiles.GetAt(iStrIdx-1);
		if (SHGetFileInfo(FileName,0,&psfi,sizeof(SHFILEINFO),
			                SHGFI_ICON|SHGFI_SMALLICON ))
		{ //      .     SHGetFileInfo 
			//    .        
			for (int i=0; i<=m_aIdx.GetUpperBound(); i++)
				if (m_aIdx.GetAt(i) == psfi.iIcon)
						break;
			// ?  -
			if ((i > m_aIdx.GetUpperBound()) || 
				  (m_aIdx.GetUpperBound() == -1))
			{//     -,     
			 //   
				m_aIdx.Add(psfi.iIcon);
				idx = m_IconList.Add(psfi.hIcon);
			}
			else
				idx = m_iBaseIconQty + i;
			//     
			m_NetTree.SetItemImage( hItem, idx, idx);
		};
	};
}
//   
void CNetFinderDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}


//     
UINT ThreadSearchProc( LPVOID pParam )
{
	CNetFinderDlg *NetF = (CNetFinderDlg*) pParam;
	NetF->Search();

	return 0;
};
//        
//   ,      ,    
UINT ThreadShellExecute( LPVOID pParam )
{
	CString FileName((LPCTSTR)pParam),
					FolderName = FileName;
	int i = FileName.ReverseFind('.');
	if (i != -1)
	{
		i = FileName.ReverseFind('\\');
		FolderName = FileName.Left(i);
	};
	//    !
	ShellExecute(AfxGetApp()->m_pMainWnd->m_hWnd,"open",FileName,NULL,FolderName,SW_SHOWNORMAL);
	return 0;
};
